> For the complete documentation index, see [llms.txt](https://docs.definer.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.definer.org/copy-of-definer.org/smart-contract-modules/modifiers.md).

# Modifiers

### Overview

We describe all the modifiers used in our contracts here.

### onlySupportedToken(token)

The token need to be registered in TokenRegistry, otherwise it will throw "Unsupported token" error.

### onlyEnabledToken(token)

The token need to be enabled in TokenRegistry, otherwise it will throw "The token is not enabled" error. One token can be registered but disabled later.

### nonReentrant

We are using this modifier provided by InitializableReentrancyGuard contract of OpenZeppelin to avoid reentrancy attack.

### whenNotPaused

We added a flag variable called `_paused` to our contract, and if we set that variable to true the methods with this modifier can't be called. This is used to temporarily pause some functions in our contracts for emergency issues.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.definer.org/copy-of-definer.org/smart-contract-modules/modifiers.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
